#ifndef __GTGLOBALS_H_
#define __GTGLOBALS_H_

#include <boost/thread/mutex.hpp>
#include <boost/thread/condition.hpp>
#include <NovaGlobalTrigger/GTConfig.h>
#include <NovaGlobalTrigger/GT.h>
#include <NovaGlobalTrigger/GT_Throttle.h>

// define this here since much GT stuff includes this file, and it needs set 
// per file at compile time

GT_NAMESPACE_BEGIN

#ifdef DEFINE_GLOBALS
#define GLOBAL
#else // !DEFINE_GLOBALS
#define GLOBAL extern
#endif

GLOBAL int32_t logLevel;
GLOBAL boost::mutex logLevel_mutex;

GLOBAL int32_t partNumber;
GLOBAL boost::mutex partNumber_mutex;

GLOBAL uint32_t MilliSliceSize;
GLOBAL boost::mutex MilliSliceSize_mutex;

GLOBAL bool offsetEnable;
GLOBAL struct timeval offsetT0, deltaT;
GLOBAL boost::mutex Offset_mutex;

GLOBAL time_t timeZoneDiff;
GLOBAL boost::mutex timeZoneDiff_mutex;

GLOBAL GTConfigurationSet gtCfgSet;
GLOBAL boost::mutex gtCfgSet_mutex;

GLOBAL bool Triggering;
GLOBAL boost::mutex Triggering_mutex;
GLOBAL boost::condition_variable Triggering_cond;
GLOBAL boost::mutex Wait_mutex;

// triggering queues
GLOBAL boost::mutex Queue_mutex;
GLOBAL boost::mutex Throttle_mutex;
GLOBAL throttlePipeline GlobalTrigThrottle;  // overall trigger rate
GLOBAL bool saneStats;    // if true, don't throttle till the queue is full
GLOBAL throttlePipeline DDTTrigThrottle;     // just the DDT total rate

GT_NAMESPACE_END

#endif // __GTGLOBALS_H_
