#ifndef __GT_LONGTRIGS_H_
#define __GT_LONGTRIGS_H_

#include <sys/types.h>
#include <boost/thread/mutex.hpp>

#include <DAQDataFormats/RawTrigger.h>

#include <NovaGlobalTrigger/GT.h>

GT_NAMESPACE_BEGIN

class GTLongTrigs {

public:

  GTLongTrigs(uint32_t);   // Constructor
  //      ~GTLongTrigs();          // Destructor not needed?

  // methods

  uint64_t adjustTrigger(daqdataformats::RawTrigger*); // correct the given 
                                                       // trigger to have a 
			 			       // millislice sized 
						       // length

private:

  // data
  uint64_t NTrig;                        // how many total triggers get made
  uint64_t TrigCount;                    // how many triggers are left to make
  uint32_t TrigLeft;                     // length of last trigger in sequence
                                         // all but the last are the same
                                         // size as the MilliSlice
  bool     first;

  // methods
};

GT_NAMESPACE_END

#endif // __GT_LONGTRIGS_H_
