#ifndef __GTSUPERNOVALISTENER_H_
#define __GTSUPERNOVALISTENER_H_

#include <NovaTimingUtilities/TimingUtilities.h>
#include <NovaGlobalTrigger/TriggerGenerator.h>
#include <NovaSuperNova/SNDataBuffer.h>

const long msec=novadaq::timeutils::NOVA_TIME_FACTOR/1000;
class GTSuperNovaListener : public TriggerGenerator
{
  private:
    bool configured;
    supernova::DataBuffer inBuffer;
    supernova::DataBuffer* outBuffer_ptr;
    int _ddsPartition;
    std::string _ddsBoxName;
    supernova::TimeType _blockTimeout;
  public:
    GTSuperNovaListener():configured(false),inBuffer(100,10),outBuffer_ptr(0){}
    void configure();
    void work();
    void setOutputBuffer(supernova::DataBuffer& outBuffer){outBuffer_ptr=&outBuffer;}
    //functions to forward blocks to he processing buffer
    void forwardNextBlock();
    void forwardFilledBlocks();
    void forwardExpiredBlocks(supernova::TimeType currentTime);
};

#endif
