/*
 * SNEWSMessageInfo implementation file
 */
#include "NovaSNEWSInterface/SNEWSMessageInfo.h"
#include <iostream>

using namespace nova::NovaSNEWSInterface;

SNEWSMessageInfo::SNEWSMessageInfo(uint64_t const time, int const type) :
_messagetime(time)
{
  if (_checkMessageTypeRange(type)) {
    _messagetype = static_cast<MessageType>(type);
  }
  else {
    _messagetype = kTestConnection;
    //log error
  }
}

bool SNEWSMessageInfo::_checkMessageTypeRange(int const type) {
  return (type>=0 && type < kNMessageType);
}


int SNEWSMessageInfo::getMessageTypeFromName(std::string const& name)
{
  int ret = -1;
#define NAME_CHECK(arg) if(name == #arg) ret = k##arg;
  NAME_CHECK(SNEWSTrigger);
  NAME_CHECK(SNEWSBeatSlow);
  NAME_CHECK(SNEWSBeatFast);
  NAME_CHECK(Fake);
#undef NAME_CHECK
  return ret;
}

std::string SNEWSMessageInfo::getMessageNameFromType(int type)
{
  std::string ret = "Undefined";
#define NAME_CHECK(arg) if(type == k##arg) ret = #arg;
  NAME_CHECK(SNEWSTrigger);
  NAME_CHECK(SNEWSBeatSlow);
  NAME_CHECK(SNEWSBeatFast);
  NAME_CHECK(Fake);
#undef NAME_CHECK
  return ret;
}

std::list< int > SNEWSMessageInfo::allMessageTypes() {
  std::list< int > l;
  for (int i = 0; i!= kNMessageType; ++i) l.push_back(i);
  return l;
}

void SNEWSMessageInfo::set (uint64_t const time, int const type)
{
  _messagetime = time;
  if (_checkMessageTypeRange(type)) {
    _messagetype = static_cast<MessageType>(type);
  }
  else {
    _messagetype = kTestConnection;
    //log error
  }
}
