// Copyright (c) 2005-2014 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#include <NovaSNEWSInterface/SNEWSSenderConfig.h>

namespace novadaq
{
  namespace nsi
  {
    template <class X>
    struct copyTraits
    {
      static void copyNeededFields(X const& source, X& target) {}
      template <class Y>
      static void copyNeededFields(X const& source, Y& target) {}
    };

    template <>
    struct copyTraits<SNEWSDestinationType>
    {
      static void copyNeededFields(SNEWSDestinationType const& source, SNEWSDestinationType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(SNEWSDestinationType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<SNEWSMessageDestinationType>
    {
      static void copyNeededFields(SNEWSMessageDestinationType const& source, SNEWSMessageDestinationType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(SNEWSMessageDestinationType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<SNEWSMessageTypeSetType>
    {
      static void copyNeededFields(SNEWSMessageTypeSetType const& source, SNEWSMessageTypeSetType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(SNEWSMessageTypeSetType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<SNEWSMessageTypeType>
    {
      static void copyNeededFields(SNEWSMessageTypeType const& source, SNEWSMessageTypeType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(SNEWSMessageTypeType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<SNEWSSenderConfigType>
    {
      static void copyNeededFields(SNEWSSenderConfigType const& source, SNEWSSenderConfigType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(SNEWSSenderConfigType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    // SNEWSSenderConfigType
    // 

    const SNEWSSenderConfigType::SNEWSMessageDestination_type& SNEWSSenderConfigType::
    SNEWSMessageDestination () const
    {
      return this->SNEWSMessageDestination_.get ();
    }

    SNEWSSenderConfigType::SNEWSMessageDestination_type& SNEWSSenderConfigType::
    SNEWSMessageDestination ()
    {
      return this->SNEWSMessageDestination_.get ();
    }

    const SNEWSSenderConfigType::SNEWSMessageDestination_type& SNEWSSenderConfigType::
    getSNEWSMessageDestination () const
    {
      return this->SNEWSMessageDestination_.get ();
    }

    bool SNEWSSenderConfigType::
    hasSNEWSMessageDestination () const
    {
      return this->SNEWSMessageDestination_.present ();
    }

    void SNEWSSenderConfigType::
    SNEWSMessageDestination (const SNEWSMessageDestination_type& x)
    {
      this->SNEWSMessageDestination_.set (x);
    }

    void SNEWSSenderConfigType::
    setSNEWSMessageDestination (const SNEWSMessageDestination_type& x)
    {
      this->SNEWSMessageDestination_.set (x);
    }

    void SNEWSSenderConfigType::
    SNEWSMessageDestination (::std::auto_ptr< SNEWSMessageDestination_type > x)
    {
      this->SNEWSMessageDestination_.set (x);
    }


    // SNEWSMessageDestinationType
    // 

    const SNEWSMessageDestinationType::SNEWSDestination_type& SNEWSMessageDestinationType::
    SNEWSDestination () const
    {
      return this->SNEWSDestination_.get ();
    }

    SNEWSMessageDestinationType::SNEWSDestination_type& SNEWSMessageDestinationType::
    SNEWSDestination ()
    {
      return this->SNEWSDestination_.get ();
    }

    const SNEWSMessageDestinationType::SNEWSDestination_type& SNEWSMessageDestinationType::
    getSNEWSDestination () const
    {
      return this->SNEWSDestination_.get ();
    }

    bool SNEWSMessageDestinationType::
    hasSNEWSDestination () const
    {
      return this->SNEWSDestination_.present ();
    }

    void SNEWSMessageDestinationType::
    SNEWSDestination (const SNEWSDestination_type& x)
    {
      this->SNEWSDestination_.set (x);
    }

    void SNEWSMessageDestinationType::
    setSNEWSDestination (const SNEWSDestination_type& x)
    {
      this->SNEWSDestination_.set (x);
    }

    void SNEWSMessageDestinationType::
    SNEWSDestination (::std::auto_ptr< SNEWSDestination_type > x)
    {
      this->SNEWSDestination_.set (x);
    }

    const SNEWSMessageDestinationType::SNEWSMessageTypeSet_type& SNEWSMessageDestinationType::
    SNEWSMessageTypeSet () const
    {
      return this->SNEWSMessageTypeSet_.get ();
    }

    SNEWSMessageDestinationType::SNEWSMessageTypeSet_type& SNEWSMessageDestinationType::
    SNEWSMessageTypeSet ()
    {
      return this->SNEWSMessageTypeSet_.get ();
    }

    const SNEWSMessageDestinationType::SNEWSMessageTypeSet_type& SNEWSMessageDestinationType::
    getSNEWSMessageTypeSet () const
    {
      return this->SNEWSMessageTypeSet_.get ();
    }

    bool SNEWSMessageDestinationType::
    hasSNEWSMessageTypeSet () const
    {
      return this->SNEWSMessageTypeSet_.present ();
    }

    void SNEWSMessageDestinationType::
    SNEWSMessageTypeSet (const SNEWSMessageTypeSet_type& x)
    {
      this->SNEWSMessageTypeSet_.set (x);
    }

    void SNEWSMessageDestinationType::
    setSNEWSMessageTypeSet (const SNEWSMessageTypeSet_type& x)
    {
      this->SNEWSMessageTypeSet_.set (x);
    }

    void SNEWSMessageDestinationType::
    SNEWSMessageTypeSet (::std::auto_ptr< SNEWSMessageTypeSet_type > x)
    {
      this->SNEWSMessageTypeSet_.set (x);
    }


    // SNEWSDestinationType
    // 

    const SNEWSDestinationType::host_type& SNEWSDestinationType::
    host () const
    {
      return this->host_.get ();
    }

    SNEWSDestinationType::host_type& SNEWSDestinationType::
    host ()
    {
      return this->host_.get ();
    }

    const SNEWSDestinationType::host_type& SNEWSDestinationType::
    getHost () const
    {
      return this->host_.get ();
    }

    bool SNEWSDestinationType::
    hasHost () const
    {
      return this->host_.present ();
    }

    void SNEWSDestinationType::
    host (const host_type& x)
    {
      this->host_.set (x);
    }

    void SNEWSDestinationType::
    setHost (const host_type& x)
    {
      this->host_.set (x);
    }

    void SNEWSDestinationType::
    host (::std::auto_ptr< host_type > x)
    {
      this->host_.set (x);
    }

    const SNEWSDestinationType::port_type& SNEWSDestinationType::
    port () const
    {
      return this->port_.get ();
    }

    SNEWSDestinationType::port_type& SNEWSDestinationType::
    port ()
    {
      return this->port_.get ();
    }

    const SNEWSDestinationType::port_type& SNEWSDestinationType::
    getPort () const
    {
      return this->port_.get ();
    }

    bool SNEWSDestinationType::
    hasPort () const
    {
      return this->port_.present ();
    }

    void SNEWSDestinationType::
    port (const port_type& x)
    {
      this->port_.set (x);
    }

    void SNEWSDestinationType::
    setPort (const port_type& x)
    {
      this->port_.set (x);
    }


    // SNEWSMessageTypeSetType
    // 

    const SNEWSMessageTypeSetType::SNEWSMessageType_sequence& SNEWSMessageTypeSetType::
    SNEWSMessageType () const
    {
      return this->SNEWSMessageType_;
    }

    SNEWSMessageTypeSetType::SNEWSMessageType_sequence& SNEWSMessageTypeSetType::
    SNEWSMessageType ()
    {
      return this->SNEWSMessageType_;
    }

    ::xml_schema::integer SNEWSMessageTypeSetType::
    getSNEWSMessageTypeCount () const
    {
      return this->SNEWSMessageType_.size ();
    }

    const SNEWSMessageTypeSetType::SNEWSMessageType_type& SNEWSMessageTypeSetType::
    getSNEWSMessageType (int index) const
    {
      return this->SNEWSMessageType_[index];
    }

    SNEWSMessageTypeSetType::SNEWSMessageType_type& SNEWSMessageTypeSetType::
    getSNEWSMessageTypeReference (int index)
    {
      return this->SNEWSMessageType_[index];
    }

    bool SNEWSMessageTypeSetType::
    hasSNEWSMessageType () const
    {
      return ! (this->SNEWSMessageType_.empty ());
    }

    void SNEWSMessageTypeSetType::
    removeAllSNEWSMessageType ()
    {
      this->SNEWSMessageType_.clear ();
    }

    void SNEWSMessageTypeSetType::
    SNEWSMessageType (const SNEWSMessageType_sequence& s)
    {
      this->SNEWSMessageType_ = s;
    }

    void SNEWSMessageTypeSetType::
    addSNEWSMessageType (const SNEWSMessageTypeSetType::SNEWSMessageType_type& newSNEWSMessageType)
    {
      this->SNEWSMessageType_.push_back (newSNEWSMessageType);
    }


    // SNEWSMessageTypeType
    // 

    const SNEWSMessageTypeType::name_type& SNEWSMessageTypeType::
    name () const
    {
      return this->name_.get ();
    }

    SNEWSMessageTypeType::name_type& SNEWSMessageTypeType::
    name ()
    {
      return this->name_.get ();
    }

    const SNEWSMessageTypeType::name_type& SNEWSMessageTypeType::
    getName () const
    {
      return this->name_.get ();
    }

    bool SNEWSMessageTypeType::
    hasName () const
    {
      return this->name_.present ();
    }

    void SNEWSMessageTypeType::
    name (const name_type& x)
    {
      this->name_.set (x);
    }

    void SNEWSMessageTypeType::
    setName (const name_type& x)
    {
      this->name_.set (x);
    }

    void SNEWSMessageTypeType::
    name (::std::auto_ptr< name_type > x)
    {
      this->name_.set (x);
    }
  }
}

#include <xsd/cxx/xml/dom/parsing-source.hxx>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

namespace novadaq
{
  namespace nsi
  {
    // SNEWSSenderConfigType
    //

    SNEWSSenderConfigType::
    SNEWSSenderConfigType ()
    : ::xml_schema::type (),
      SNEWSMessageDestination_ (this)
    {
    }

    SNEWSSenderConfigType::
    SNEWSSenderConfigType (const SNEWSMessageDestination_type& SNEWSMessageDestination)
    : ::xml_schema::type (),
      SNEWSMessageDestination_ (SNEWSMessageDestination, this)
    {
    }

    SNEWSSenderConfigType::
    SNEWSSenderConfigType (::std::auto_ptr< SNEWSMessageDestination_type > SNEWSMessageDestination)
    : ::xml_schema::type (),
      SNEWSMessageDestination_ (SNEWSMessageDestination, this)
    {
    }

    SNEWSSenderConfigType::
    SNEWSSenderConfigType (const SNEWSSenderConfigType& x,
                           ::xml_schema::flags f,
                           ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      SNEWSMessageDestination_ (x.SNEWSMessageDestination_, f, this)
    {
    }

    SNEWSSenderConfigType::
    SNEWSSenderConfigType (const ::xercesc::DOMElement& e,
                           ::xml_schema::flags f,
                           ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      SNEWSMessageDestination_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
        this->parse (p, f);
      }
    }

    void SNEWSSenderConfigType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // SNEWSMessageDestination
        //
        if (n.name () == "SNEWSMessageDestination" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< SNEWSMessageDestination_type > r (
            SNEWSMessageDestination_traits::create (i, f, this));

          if (!SNEWSMessageDestination_.present ())
          {
            this->SNEWSMessageDestination_.set (r);
            continue;
          }
        }

        break;
      }

      if (!SNEWSMessageDestination_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected element (SNEWSSenderConfigType::SNEWSMessageDestination) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_element< char > (
            "SNEWSMessageDestination",
            "");
        }
      }
    }

    SNEWSSenderConfigType* SNEWSSenderConfigType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class SNEWSSenderConfigType (*this, f, c);
    }

    SNEWSSenderConfigType& SNEWSSenderConfigType::
    operator= (const SNEWSSenderConfigType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->SNEWSMessageDestination_ = x.SNEWSMessageDestination_;
      }

      return *this;
    }

    SNEWSSenderConfigType::
    ~SNEWSSenderConfigType ()
    {
    }

    ::std::string SNEWSSenderConfigType::
    serialize () const
    {
      // To avoid problems with multi-threaded access to
      // CST XSD ser/deserialization code and underlying
      // Xerces-C++ code, we prevent concurrent access
      // to any serialization code by any class that
      // inherits from XMLSerializable via the use of a
      // static mutex in XMLSerializable.
      boost::mutex::scoped_lock lock(_serializationMutex);

      ::std::ostringstream oss;
      SNEWSSenderConfig (oss, *this);
      return oss.str();
    }

    void SNEWSSenderConfigType::
    deserialize (const ::std::string& serializedData)
    {
      // To avoid problems with multi-threaded access to
      // CST XSD ser/deserialization code and underlying
      // Xerces-C++ code, we prevent concurrent access
      // to any deserialization code by any class that
      // inherits from XMLSerializable via the use of a
      // static mutex in XMLSerializable.
      boost::mutex::scoped_lock lock(_serializationMutex);

      // initialization for XSD
      ::xml_schema::flags flags = ::xml_schema::flags::dont_validate;
      ::xsd::cxx::xml::auto_initializer autoInit
            ((flags & ::xml_schema::flags::dont_initialize) == 0,
             (flags & ::xml_schema::flags::keep_dom) == 0);
      ::xsd::cxx::tree::error_handler< char > errorHandler;
      ::xml_schema::properties props;

      // wrap the string in an input stream
      ::std::istringstream iss (serializedData);
      ::xsd::cxx::xml::sax::std_input_source isrc (iss);

      // create a DOM from the input stream
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > doc (
          ::xsd::cxx::xml::dom::parse< char > (isrc, errorHandler, props, flags));
      errorHandler.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      // do the deserialization
      ::xsd::cxx::xml::dom::parser< char > parser (*(doc->getDocumentElement()), true, false, true);
      this->parse (parser, flags);
    }

    ::std::string SNEWSSenderConfigType::
    getClassName () const
    {
      return "novadaq::nsi::SNEWSSenderConfigType";
    }

    ::boost::shared_ptr< ::novadaq::XMLSerializable > SNEWSSenderConfigType::
    clone () const
    {
      SNEWSSenderConfigType *copy = this->_clone ();
      boost::shared_ptr<novadaq::XMLSerializable> copyPtr (copy);
      return copyPtr;
    }

    void SNEWSSenderConfigType::
    registerForDeserialization ()
    {
      boost::shared_ptr<novadaq::XMLSerializable> msgPtr;
      novadaq::XMLDeserializationRegistry&
        deserRegistry = novadaq::XMLDeserializationRegistry::getInstance();
      msgPtr.reset(new SNEWSSenderConfigType());
      deserRegistry.registerClass(msgPtr->getClassName(), msgPtr);
    }

    void SNEWSSenderConfigType::
    copyNeededFields (const SNEWSSenderConfigType& x)
    {
      if (x.hasSNEWSMessageDestination()) {
        if (! this->hasSNEWSMessageDestination()) {
          this->setSNEWSMessageDestination(x.getSNEWSMessageDestination());
        }
        else {
          copyTraits<SNEWSMessageDestination_type>::copyNeededFields(x.getSNEWSMessageDestination(), this->SNEWSMessageDestination());
        }
      }
    }

    // SNEWSMessageDestinationType
    //

    SNEWSMessageDestinationType::
    SNEWSMessageDestinationType ()
    : ::xml_schema::type (),
      SNEWSDestination_ (this),
      SNEWSMessageTypeSet_ (this)
    {
    }

    SNEWSMessageDestinationType::
    SNEWSMessageDestinationType (const SNEWSDestination_type& SNEWSDestination,
                                 const SNEWSMessageTypeSet_type& SNEWSMessageTypeSet)
    : ::xml_schema::type (),
      SNEWSDestination_ (SNEWSDestination, this),
      SNEWSMessageTypeSet_ (SNEWSMessageTypeSet, this)
    {
    }

    SNEWSMessageDestinationType::
    SNEWSMessageDestinationType (::std::auto_ptr< SNEWSDestination_type > SNEWSDestination,
                                 ::std::auto_ptr< SNEWSMessageTypeSet_type > SNEWSMessageTypeSet)
    : ::xml_schema::type (),
      SNEWSDestination_ (SNEWSDestination, this),
      SNEWSMessageTypeSet_ (SNEWSMessageTypeSet, this)
    {
    }

    SNEWSMessageDestinationType::
    SNEWSMessageDestinationType (const SNEWSMessageDestinationType& x,
                                 ::xml_schema::flags f,
                                 ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      SNEWSDestination_ (x.SNEWSDestination_, f, this),
      SNEWSMessageTypeSet_ (x.SNEWSMessageTypeSet_, f, this)
    {
    }

    SNEWSMessageDestinationType::
    SNEWSMessageDestinationType (const ::xercesc::DOMElement& e,
                                 ::xml_schema::flags f,
                                 ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      SNEWSDestination_ (this),
      SNEWSMessageTypeSet_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
        this->parse (p, f);
      }
    }

    void SNEWSMessageDestinationType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // SNEWSDestination
        //
        if (n.name () == "SNEWSDestination" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< SNEWSDestination_type > r (
            SNEWSDestination_traits::create (i, f, this));

          if (!SNEWSDestination_.present ())
          {
            this->SNEWSDestination_.set (r);
            continue;
          }
        }

        // SNEWSMessageTypeSet
        //
        if (n.name () == "SNEWSMessageTypeSet" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< SNEWSMessageTypeSet_type > r (
            SNEWSMessageTypeSet_traits::create (i, f, this));

          if (!SNEWSMessageTypeSet_.present ())
          {
            this->SNEWSMessageTypeSet_.set (r);
            continue;
          }
        }

        break;
      }

      if (!SNEWSDestination_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected element (SNEWSMessageDestinationType::SNEWSDestination) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_element< char > (
            "SNEWSDestination",
            "");
        }
      }

      if (!SNEWSMessageTypeSet_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected element (SNEWSMessageDestinationType::SNEWSMessageTypeSet) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_element< char > (
            "SNEWSMessageTypeSet",
            "");
        }
      }
    }

    SNEWSMessageDestinationType* SNEWSMessageDestinationType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class SNEWSMessageDestinationType (*this, f, c);
    }

    SNEWSMessageDestinationType& SNEWSMessageDestinationType::
    operator= (const SNEWSMessageDestinationType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->SNEWSDestination_ = x.SNEWSDestination_;
        this->SNEWSMessageTypeSet_ = x.SNEWSMessageTypeSet_;
      }

      return *this;
    }

    SNEWSMessageDestinationType::
    ~SNEWSMessageDestinationType ()
    {
    }

    void SNEWSMessageDestinationType::
    copyNeededFields (const SNEWSMessageDestinationType& x)
    {
      if (x.hasSNEWSDestination()) {
        if (! this->hasSNEWSDestination()) {
          this->setSNEWSDestination(x.getSNEWSDestination());
        }
        else {
          copyTraits<SNEWSDestination_type>::copyNeededFields(x.getSNEWSDestination(), this->SNEWSDestination());
        }
      }
      if (x.hasSNEWSMessageTypeSet()) {
        if (! this->hasSNEWSMessageTypeSet()) {
          this->setSNEWSMessageTypeSet(x.getSNEWSMessageTypeSet());
        }
        else {
          copyTraits<SNEWSMessageTypeSet_type>::copyNeededFields(x.getSNEWSMessageTypeSet(), this->SNEWSMessageTypeSet());
        }
      }
    }

    // SNEWSDestinationType
    //

    SNEWSDestinationType::
    SNEWSDestinationType ()
    : ::xml_schema::type (),
      host_ (this),
      port_ (this)
    {
    }

    SNEWSDestinationType::
    SNEWSDestinationType (const host_type& host,
                          const port_type& port)
    : ::xml_schema::type (),
      host_ (host, this),
      port_ (port, this)
    {
    }

    SNEWSDestinationType::
    SNEWSDestinationType (const SNEWSDestinationType& x,
                          ::xml_schema::flags f,
                          ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      host_ (x.host_, f, this),
      port_ (x.port_, f, this)
    {
    }

    SNEWSDestinationType::
    SNEWSDestinationType (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f,
                          ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      host_ (this),
      port_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
        this->parse (p, f);
      }
    }

    void SNEWSDestinationType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "host" && n.namespace_ ().empty ())
        {
          this->host_.set (host_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "port" && n.namespace_ ().empty ())
        {
          this->port_.set (port_traits::create (i, f, this));
          continue;
        }
      }

      if (!host_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (SNEWSDestinationType::host) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "host",
            "");
        }
      }

      if (!port_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (SNEWSDestinationType::port) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "port",
            "");
        }
      }
    }

    SNEWSDestinationType* SNEWSDestinationType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class SNEWSDestinationType (*this, f, c);
    }

    SNEWSDestinationType& SNEWSDestinationType::
    operator= (const SNEWSDestinationType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->host_ = x.host_;
        this->port_ = x.port_;
      }

      return *this;
    }

    SNEWSDestinationType::
    ~SNEWSDestinationType ()
    {
    }

    void SNEWSDestinationType::
    copyNeededFields (const SNEWSDestinationType& x)
    {
      if (x.hasHost()) {
        if (! this->hasHost()) {
          this->setHost(x.getHost());
        }
        else {
          copyTraits<host_type>::copyNeededFields(x.getHost(), this->host());
        }
      }
      if (x.hasPort()) {
        if (! this->hasPort()) {
          this->setPort(x.getPort());
        }
        else {
          copyTraits<port_type>::copyNeededFields(x.getPort(), this->port());
        }
      }
    }

    // SNEWSMessageTypeSetType
    //

    SNEWSMessageTypeSetType::
    SNEWSMessageTypeSetType ()
    : ::xml_schema::type (),
      SNEWSMessageType_ (this)
    {
    }

    SNEWSMessageTypeSetType::
    SNEWSMessageTypeSetType (const SNEWSMessageTypeSetType& x,
                             ::xml_schema::flags f,
                             ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      SNEWSMessageType_ (x.SNEWSMessageType_, f, this)
    {
    }

    SNEWSMessageTypeSetType::
    SNEWSMessageTypeSetType (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f,
                             ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      SNEWSMessageType_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
        this->parse (p, f);
      }
    }

    void SNEWSMessageTypeSetType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // SNEWSMessageType
        //
        if (n.name () == "SNEWSMessageType" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< SNEWSMessageType_type > r (
            SNEWSMessageType_traits::create (i, f, this));

          this->SNEWSMessageType_.push_back (r);
          continue;
        }

        break;
      }
    }

    SNEWSMessageTypeSetType* SNEWSMessageTypeSetType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class SNEWSMessageTypeSetType (*this, f, c);
    }

    SNEWSMessageTypeSetType& SNEWSMessageTypeSetType::
    operator= (const SNEWSMessageTypeSetType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->SNEWSMessageType_ = x.SNEWSMessageType_;
      }

      return *this;
    }

    SNEWSMessageTypeSetType::
    ~SNEWSMessageTypeSetType ()
    {
    }

    void SNEWSMessageTypeSetType::
    copyNeededFields (const SNEWSMessageTypeSetType& x)
    {
      if (x.hasSNEWSMessageType() && x.getSNEWSMessageTypeCount() > 0) {
        if (! this->hasSNEWSMessageType() || this->getSNEWSMessageTypeCount() == 0) {
          for (::xml_schema::integer idx = 0; idx < x.getSNEWSMessageTypeCount(); ++idx) {
              this->addSNEWSMessageType(x.getSNEWSMessageType(idx));
          }
        }
        //else {
        //  copyTraits<SNEWSMessageType_type>::copyNeededFields(x.getSNEWSMessageType(), this->SNEWSMessageType());
        //}
      }
    }

    // SNEWSMessageTypeType
    //

    SNEWSMessageTypeType::
    SNEWSMessageTypeType ()
    : ::xml_schema::type (),
      name_ (this)
    {
    }

    SNEWSMessageTypeType::
    SNEWSMessageTypeType (const name_type& name)
    : ::xml_schema::type (),
      name_ (name, this)
    {
    }

    SNEWSMessageTypeType::
    SNEWSMessageTypeType (const SNEWSMessageTypeType& x,
                          ::xml_schema::flags f,
                          ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      name_ (x.name_, f, this)
    {
    }

    SNEWSMessageTypeType::
    SNEWSMessageTypeType (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f,
                          ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      name_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
        this->parse (p, f);
      }
    }

    void SNEWSMessageTypeType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "name" && n.namespace_ ().empty ())
        {
          this->name_.set (name_traits::create (i, f, this));
          continue;
        }
      }

      if (!name_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (SNEWSMessageTypeType::name) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "name",
            "");
        }
      }
    }

    SNEWSMessageTypeType* SNEWSMessageTypeType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class SNEWSMessageTypeType (*this, f, c);
    }

    SNEWSMessageTypeType& SNEWSMessageTypeType::
    operator= (const SNEWSMessageTypeType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->name_ = x.name_;
      }

      return *this;
    }

    SNEWSMessageTypeType::
    ~SNEWSMessageTypeType ()
    {
    }

    void SNEWSMessageTypeType::
    copyNeededFields (const SNEWSMessageTypeType& x)
    {
      if (x.hasName()) {
        if (! this->hasName()) {
          this->setName(x.getName());
        }
        else {
          copyTraits<name_type>::copyNeededFields(x.getName(), this->name());
        }
      }
    }
  }
}

#include <istream>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

namespace novadaq
{
  namespace nsi
  {
    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (const ::std::string& u,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::tree::error_handler< char > h;

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      return ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType > (
        ::novadaq::nsi::SNEWSSenderConfig (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (const ::std::string& u,
                       ::xml_schema::error_handler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType > (
        ::novadaq::nsi::SNEWSSenderConfig (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (const ::std::string& u,
                       ::xercesc::DOMErrorHandler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType > (
        ::novadaq::nsi::SNEWSSenderConfig (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (::std::istream& is,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::novadaq::nsi::SNEWSSenderConfig (isrc, f, p);
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (::std::istream& is,
                       ::xml_schema::error_handler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::novadaq::nsi::SNEWSSenderConfig (isrc, h, f, p);
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (::std::istream& is,
                       ::xercesc::DOMErrorHandler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::novadaq::nsi::SNEWSSenderConfig (isrc, h, f, p);
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (::std::istream& is,
                       const ::std::string& sid,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::novadaq::nsi::SNEWSSenderConfig (isrc, f, p);
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (::std::istream& is,
                       const ::std::string& sid,
                       ::xml_schema::error_handler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::novadaq::nsi::SNEWSSenderConfig (isrc, h, f, p);
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (::std::istream& is,
                       const ::std::string& sid,
                       ::xercesc::DOMErrorHandler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::novadaq::nsi::SNEWSSenderConfig (isrc, h, f, p);
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (::xercesc::InputSource& i,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xsd::cxx::tree::error_handler< char > h;

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      return ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType > (
        ::novadaq::nsi::SNEWSSenderConfig (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (::xercesc::InputSource& i,
                       ::xml_schema::error_handler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType > (
        ::novadaq::nsi::SNEWSSenderConfig (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (::xercesc::InputSource& i,
                       ::xercesc::DOMErrorHandler& h,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType > (
        ::novadaq::nsi::SNEWSSenderConfig (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (const ::xercesc::DOMDocument& doc,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties& p)
    {
      if (f & ::xml_schema::flags::keep_dom)
      {
        ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
          static_cast< ::xercesc::DOMDocument* > (doc.cloneNode (true)));

        return ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType > (
          ::novadaq::nsi::SNEWSSenderConfig (
            d, f | ::xml_schema::flags::own_dom, p));
      }

      const ::xercesc::DOMElement& e (*doc.getDocumentElement ());
      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (n.name () == "SNEWSSenderConfig" &&
          n.namespace_ () == "")
      {
        ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType > r (
          ::xsd::cxx::tree::traits< ::novadaq::nsi::SNEWSSenderConfigType, char >::create (
            e, f, 0));
        return r;
      }

      throw ::xsd::cxx::tree::unexpected_element < char > (
        n.name (),
        n.namespace_ (),
        "SNEWSSenderConfig",
        "");
    }

    ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType >
    SNEWSSenderConfig (::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d,
                       ::xml_schema::flags f,
                       const ::xml_schema::properties&)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > c (
        ((f & ::xml_schema::flags::keep_dom) &&
         !(f & ::xml_schema::flags::own_dom))
        ? static_cast< ::xercesc::DOMDocument* > (d->cloneNode (true))
        : 0);

      ::xercesc::DOMDocument& doc (c.get () ? *c : *d);
      const ::xercesc::DOMElement& e (*doc.getDocumentElement ());

      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (f & ::xml_schema::flags::keep_dom)
        doc.setUserData (::xml_schema::dom::tree_node_key,
                         (c.get () ? &c : &d),
                         0);

      if (n.name () == "SNEWSSenderConfig" &&
          n.namespace_ () == "")
      {
        ::std::auto_ptr< ::novadaq::nsi::SNEWSSenderConfigType > r (
          ::xsd::cxx::tree::traits< ::novadaq::nsi::SNEWSSenderConfigType, char >::create (
            e, f, 0));
        return r;
      }

      throw ::xsd::cxx::tree::unexpected_element < char > (
        n.name (),
        n.namespace_ (),
        "SNEWSSenderConfig",
        "");
    }
  }
}

#include <ostream>
#include <xsd/cxx/tree/error-handler.hxx>
#include <xsd/cxx/xml/dom/serialization-source.hxx>

namespace novadaq
{
  namespace nsi
  {
    void
    SNEWSSenderConfig (::std::ostream& o,
                       const ::novadaq::nsi::SNEWSSenderConfigType& s,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0);

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nsi::SNEWSSenderConfig (s, m, f));

      ::xsd::cxx::tree::error_handler< char > h;

      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
      }
    }

    void
    SNEWSSenderConfig (::std::ostream& o,
                       const ::novadaq::nsi::SNEWSSenderConfigType& s,
                       ::xml_schema::error_handler& h,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0);

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nsi::SNEWSSenderConfig (s, m, f));
      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    SNEWSSenderConfig (::std::ostream& o,
                       const ::novadaq::nsi::SNEWSSenderConfigType& s,
                       ::xercesc::DOMErrorHandler& h,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nsi::SNEWSSenderConfig (s, m, f));
      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    SNEWSSenderConfig (::xercesc::XMLFormatTarget& t,
                       const ::novadaq::nsi::SNEWSSenderConfigType& s,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nsi::SNEWSSenderConfig (s, m, f));

      ::xsd::cxx::tree::error_handler< char > h;

      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
      }
    }

    void
    SNEWSSenderConfig (::xercesc::XMLFormatTarget& t,
                       const ::novadaq::nsi::SNEWSSenderConfigType& s,
                       ::xml_schema::error_handler& h,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nsi::SNEWSSenderConfig (s, m, f));
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    SNEWSSenderConfig (::xercesc::XMLFormatTarget& t,
                       const ::novadaq::nsi::SNEWSSenderConfigType& s,
                       ::xercesc::DOMErrorHandler& h,
                       const ::xml_schema::namespace_infomap& m,
                       const ::std::string& e,
                       ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nsi::SNEWSSenderConfig (s, m, f));
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    SNEWSSenderConfig (::xercesc::DOMDocument& d,
                       const ::novadaq::nsi::SNEWSSenderConfigType& s,
                       ::xml_schema::flags)
    {
      ::xercesc::DOMElement& e (*d.getDocumentElement ());
      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (n.name () == "SNEWSSenderConfig" &&
          n.namespace_ () == "")
      {
        e << s;
      }
      else
      {
        throw ::xsd::cxx::tree::unexpected_element < char > (
          n.name (),
          n.namespace_ (),
          "SNEWSSenderConfig",
          "");
      }
    }

    ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument >
    SNEWSSenderConfig (const ::novadaq::nsi::SNEWSSenderConfigType& s,
                       const ::xml_schema::namespace_infomap& m,
                       ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::serialize< char > (
          "SNEWSSenderConfig",
          "",
          m, f));

      ::novadaq::nsi::SNEWSSenderConfig (*d, s, f);
      return d;
    }

    void
    operator<< (::xercesc::DOMElement& e, const SNEWSSenderConfigType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // SNEWSMessageDestination
      //
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "SNEWSMessageDestination",
            e));

        if (! i.hasSNEWSMessageDestination ()) {
          std::cerr << "WARNING: attempting to serialize a SNEWSSenderConfigType with an empty SNEWSMessageDestination field!" << std::endl;
        }
        s << i.SNEWSMessageDestination ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const SNEWSMessageDestinationType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // SNEWSDestination
      //
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "SNEWSDestination",
            e));

        if (! i.hasSNEWSDestination ()) {
          std::cerr << "WARNING: attempting to serialize a SNEWSMessageDestinationType with an empty SNEWSDestination field!" << std::endl;
        }
        s << i.SNEWSDestination ();
      }

      // SNEWSMessageTypeSet
      //
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "SNEWSMessageTypeSet",
            e));

        if (! i.hasSNEWSMessageTypeSet ()) {
          std::cerr << "WARNING: attempting to serialize a SNEWSMessageDestinationType with an empty SNEWSMessageTypeSet field!" << std::endl;
        }
        s << i.SNEWSMessageTypeSet ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const SNEWSDestinationType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // host
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "host",
            e));

        if (! i.hasHost ()) {
          std::cerr << "WARNING: attempting to serialize a SNEWSDestinationType with an empty host field!" << std::endl;
        }
        a << i.host ();
      }

      // port
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "port",
            e));

        if (! i.hasPort ()) {
          std::cerr << "WARNING: attempting to serialize a SNEWSDestinationType with an empty port field!" << std::endl;
        }
        a << i.port ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const SNEWSMessageTypeSetType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // SNEWSMessageType
      //
      for (SNEWSMessageTypeSetType::SNEWSMessageType_const_iterator
           b (i.SNEWSMessageType ().begin ()), n (i.SNEWSMessageType ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "SNEWSMessageType",
            e));

        s << *b;
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const SNEWSMessageTypeType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // name
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "name",
            e));

        if (! i.hasName ()) {
          std::cerr << "WARNING: attempting to serialize a SNEWSMessageTypeType with an empty name field!" << std::endl;
        }
        a << i.name ();
      }
    }
  }
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

