// Copyright (c) 2005-2014 Code Synthesis Tools CC
//
// This program was generated by CodeSynthesis XSD, an XML Schema to
// C++ data binding compiler.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// Furthermore, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#include <NovaSpillServer/NssSpillForwarderConfig.h>

namespace novadaq
{
  namespace nss
  {
    template <class X>
    struct copyTraits
    {
      static void copyNeededFields(X const& source, X& target) {}
      template <class Y>
      static void copyNeededFields(X const& source, Y& target) {}
    };

    template <>
    struct copyTraits<DestinationType>
    {
      static void copyNeededFields(DestinationType const& source, DestinationType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(DestinationType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<NssSpillForwarderConfigSet>
    {
      static void copyNeededFields(NssSpillForwarderConfigSet const& source, NssSpillForwarderConfigSet& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(NssSpillForwarderConfigSet const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<NssSpillForwarderConfigType>
    {
      static void copyNeededFields(NssSpillForwarderConfigType const& source, NssSpillForwarderConfigType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(NssSpillForwarderConfigType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<SpillDestinationSetType>
    {
      static void copyNeededFields(SpillDestinationSetType const& source, SpillDestinationSetType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(SpillDestinationSetType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<SpillDestinationType>
    {
      static void copyNeededFields(SpillDestinationType const& source, SpillDestinationType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(SpillDestinationType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<SpillSourceType>
    {
      static void copyNeededFields(SpillSourceType const& source, SpillSourceType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(SpillSourceType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<SpillTypeSetType>
    {
      static void copyNeededFields(SpillTypeSetType const& source, SpillTypeSetType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(SpillTypeSetType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    template <>
    struct copyTraits<SpillTypeType>
    {
      static void copyNeededFields(SpillTypeType const& source, SpillTypeType& target) {
        target.copyNeededFields(source);
      }
      template <class Y>
      static void copyNeededFields(SpillTypeType const& source, Y& target) {
        target->copyNeededFields(source);
      }
    };

    // NssSpillForwarderConfigType
    // 

    const NssSpillForwarderConfigType::SpillSource_type& NssSpillForwarderConfigType::
    SpillSource () const
    {
      return this->SpillSource_.get ();
    }

    NssSpillForwarderConfigType::SpillSource_type& NssSpillForwarderConfigType::
    SpillSource ()
    {
      return this->SpillSource_.get ();
    }

    const NssSpillForwarderConfigType::SpillSource_type& NssSpillForwarderConfigType::
    getSpillSource () const
    {
      return this->SpillSource_.get ();
    }

    bool NssSpillForwarderConfigType::
    hasSpillSource () const
    {
      return this->SpillSource_.present ();
    }

    void NssSpillForwarderConfigType::
    SpillSource (const SpillSource_type& x)
    {
      this->SpillSource_.set (x);
    }

    void NssSpillForwarderConfigType::
    setSpillSource (const SpillSource_type& x)
    {
      this->SpillSource_.set (x);
    }

    void NssSpillForwarderConfigType::
    SpillSource (::std::auto_ptr< SpillSource_type > x)
    {
      this->SpillSource_.set (x);
    }

    const NssSpillForwarderConfigType::SpillDestinationSet_sequence& NssSpillForwarderConfigType::
    SpillDestinationSet () const
    {
      return this->SpillDestinationSet_;
    }

    NssSpillForwarderConfigType::SpillDestinationSet_sequence& NssSpillForwarderConfigType::
    SpillDestinationSet ()
    {
      return this->SpillDestinationSet_;
    }

    ::xml_schema::integer NssSpillForwarderConfigType::
    getSpillDestinationSetCount () const
    {
      return this->SpillDestinationSet_.size ();
    }

    const NssSpillForwarderConfigType::SpillDestinationSet_type& NssSpillForwarderConfigType::
    getSpillDestinationSet (int index) const
    {
      return this->SpillDestinationSet_[index];
    }

    NssSpillForwarderConfigType::SpillDestinationSet_type& NssSpillForwarderConfigType::
    getSpillDestinationSetReference (int index)
    {
      return this->SpillDestinationSet_[index];
    }

    bool NssSpillForwarderConfigType::
    hasSpillDestinationSet () const
    {
      return ! (this->SpillDestinationSet_.empty ());
    }

    void NssSpillForwarderConfigType::
    removeAllSpillDestinationSet ()
    {
      this->SpillDestinationSet_.clear ();
    }

    void NssSpillForwarderConfigType::
    SpillDestinationSet (const SpillDestinationSet_sequence& s)
    {
      this->SpillDestinationSet_ = s;
    }

    void NssSpillForwarderConfigType::
    addSpillDestinationSet (const NssSpillForwarderConfigType::SpillDestinationSet_type& newSpillDestinationSet)
    {
      this->SpillDestinationSet_.push_back (newSpillDestinationSet);
    }


    // SpillSourceType
    // 

    const SpillSourceType::port_type& SpillSourceType::
    port () const
    {
      return this->port_.get ();
    }

    SpillSourceType::port_type& SpillSourceType::
    port ()
    {
      return this->port_.get ();
    }

    const SpillSourceType::port_type& SpillSourceType::
    getPort () const
    {
      return this->port_.get ();
    }

    bool SpillSourceType::
    hasPort () const
    {
      return this->port_.present ();
    }

    void SpillSourceType::
    port (const port_type& x)
    {
      this->port_.set (x);
    }

    void SpillSourceType::
    setPort (const port_type& x)
    {
      this->port_.set (x);
    }


    // SpillDestinationSetType
    // 

    const SpillDestinationSetType::SpillDestination_sequence& SpillDestinationSetType::
    SpillDestination () const
    {
      return this->SpillDestination_;
    }

    SpillDestinationSetType::SpillDestination_sequence& SpillDestinationSetType::
    SpillDestination ()
    {
      return this->SpillDestination_;
    }

    ::xml_schema::integer SpillDestinationSetType::
    getSpillDestinationCount () const
    {
      return this->SpillDestination_.size ();
    }

    const SpillDestinationSetType::SpillDestination_type& SpillDestinationSetType::
    getSpillDestination (int index) const
    {
      return this->SpillDestination_[index];
    }

    SpillDestinationSetType::SpillDestination_type& SpillDestinationSetType::
    getSpillDestinationReference (int index)
    {
      return this->SpillDestination_[index];
    }

    bool SpillDestinationSetType::
    hasSpillDestination () const
    {
      return ! (this->SpillDestination_.empty ());
    }

    void SpillDestinationSetType::
    removeAllSpillDestination ()
    {
      this->SpillDestination_.clear ();
    }

    void SpillDestinationSetType::
    SpillDestination (const SpillDestination_sequence& s)
    {
      this->SpillDestination_ = s;
    }

    void SpillDestinationSetType::
    addSpillDestination (const SpillDestinationSetType::SpillDestination_type& newSpillDestination)
    {
      this->SpillDestination_.push_back (newSpillDestination);
    }


    // SpillDestinationType
    // 

    const SpillDestinationType::Destination_type& SpillDestinationType::
    Destination () const
    {
      return this->Destination_.get ();
    }

    SpillDestinationType::Destination_type& SpillDestinationType::
    Destination ()
    {
      return this->Destination_.get ();
    }

    const SpillDestinationType::Destination_type& SpillDestinationType::
    getDestination () const
    {
      return this->Destination_.get ();
    }

    bool SpillDestinationType::
    hasDestination () const
    {
      return this->Destination_.present ();
    }

    void SpillDestinationType::
    Destination (const Destination_type& x)
    {
      this->Destination_.set (x);
    }

    void SpillDestinationType::
    setDestination (const Destination_type& x)
    {
      this->Destination_.set (x);
    }

    void SpillDestinationType::
    Destination (::std::auto_ptr< Destination_type > x)
    {
      this->Destination_.set (x);
    }

    const SpillDestinationType::SpillTypeSet_type& SpillDestinationType::
    SpillTypeSet () const
    {
      return this->SpillTypeSet_.get ();
    }

    SpillDestinationType::SpillTypeSet_type& SpillDestinationType::
    SpillTypeSet ()
    {
      return this->SpillTypeSet_.get ();
    }

    const SpillDestinationType::SpillTypeSet_type& SpillDestinationType::
    getSpillTypeSet () const
    {
      return this->SpillTypeSet_.get ();
    }

    bool SpillDestinationType::
    hasSpillTypeSet () const
    {
      return this->SpillTypeSet_.present ();
    }

    void SpillDestinationType::
    SpillTypeSet (const SpillTypeSet_type& x)
    {
      this->SpillTypeSet_.set (x);
    }

    void SpillDestinationType::
    setSpillTypeSet (const SpillTypeSet_type& x)
    {
      this->SpillTypeSet_.set (x);
    }

    void SpillDestinationType::
    SpillTypeSet (::std::auto_ptr< SpillTypeSet_type > x)
    {
      this->SpillTypeSet_.set (x);
    }


    // DestinationType
    // 

    const DestinationType::enable_type& DestinationType::
    enable () const
    {
      return this->enable_.get ();
    }

    DestinationType::enable_type& DestinationType::
    enable ()
    {
      return this->enable_.get ();
    }

    const DestinationType::enable_type& DestinationType::
    getEnable () const
    {
      return this->enable_.get ();
    }

    bool DestinationType::
    hasEnable () const
    {
      return this->enable_.present ();
    }

    void DestinationType::
    enable (const enable_type& x)
    {
      this->enable_.set (x);
    }

    void DestinationType::
    setEnable (const enable_type& x)
    {
      this->enable_.set (x);
    }

    const DestinationType::host_type& DestinationType::
    host () const
    {
      return this->host_.get ();
    }

    DestinationType::host_type& DestinationType::
    host ()
    {
      return this->host_.get ();
    }

    const DestinationType::host_type& DestinationType::
    getHost () const
    {
      return this->host_.get ();
    }

    bool DestinationType::
    hasHost () const
    {
      return this->host_.present ();
    }

    void DestinationType::
    host (const host_type& x)
    {
      this->host_.set (x);
    }

    void DestinationType::
    setHost (const host_type& x)
    {
      this->host_.set (x);
    }

    void DestinationType::
    host (::std::auto_ptr< host_type > x)
    {
      this->host_.set (x);
    }

    const DestinationType::port_type& DestinationType::
    port () const
    {
      return this->port_.get ();
    }

    DestinationType::port_type& DestinationType::
    port ()
    {
      return this->port_.get ();
    }

    const DestinationType::port_type& DestinationType::
    getPort () const
    {
      return this->port_.get ();
    }

    bool DestinationType::
    hasPort () const
    {
      return this->port_.present ();
    }

    void DestinationType::
    port (const port_type& x)
    {
      this->port_.set (x);
    }

    void DestinationType::
    setPort (const port_type& x)
    {
      this->port_.set (x);
    }


    // SpillTypeSetType
    // 

    const SpillTypeSetType::SpillType_sequence& SpillTypeSetType::
    SpillType () const
    {
      return this->SpillType_;
    }

    SpillTypeSetType::SpillType_sequence& SpillTypeSetType::
    SpillType ()
    {
      return this->SpillType_;
    }

    ::xml_schema::integer SpillTypeSetType::
    getSpillTypeCount () const
    {
      return this->SpillType_.size ();
    }

    const SpillTypeSetType::SpillType_type& SpillTypeSetType::
    getSpillType (int index) const
    {
      return this->SpillType_[index];
    }

    SpillTypeSetType::SpillType_type& SpillTypeSetType::
    getSpillTypeReference (int index)
    {
      return this->SpillType_[index];
    }

    bool SpillTypeSetType::
    hasSpillType () const
    {
      return ! (this->SpillType_.empty ());
    }

    void SpillTypeSetType::
    removeAllSpillType ()
    {
      this->SpillType_.clear ();
    }

    void SpillTypeSetType::
    SpillType (const SpillType_sequence& s)
    {
      this->SpillType_ = s;
    }

    void SpillTypeSetType::
    addSpillType (const SpillTypeSetType::SpillType_type& newSpillType)
    {
      this->SpillType_.push_back (newSpillType);
    }


    // SpillTypeType
    // 

    const SpillTypeType::name_type& SpillTypeType::
    name () const
    {
      return this->name_.get ();
    }

    SpillTypeType::name_type& SpillTypeType::
    name ()
    {
      return this->name_.get ();
    }

    const SpillTypeType::name_type& SpillTypeType::
    getName () const
    {
      return this->name_.get ();
    }

    bool SpillTypeType::
    hasName () const
    {
      return this->name_.present ();
    }

    void SpillTypeType::
    name (const name_type& x)
    {
      this->name_.set (x);
    }

    void SpillTypeType::
    setName (const name_type& x)
    {
      this->name_.set (x);
    }

    void SpillTypeType::
    name (::std::auto_ptr< name_type > x)
    {
      this->name_.set (x);
    }


    // NssSpillForwarderConfigSet
    // 

    const NssSpillForwarderConfigSet::NssSpillForwarderConfig_sequence& NssSpillForwarderConfigSet::
    NssSpillForwarderConfig () const
    {
      return this->NssSpillForwarderConfig_;
    }

    NssSpillForwarderConfigSet::NssSpillForwarderConfig_sequence& NssSpillForwarderConfigSet::
    NssSpillForwarderConfig ()
    {
      return this->NssSpillForwarderConfig_;
    }

    ::xml_schema::integer NssSpillForwarderConfigSet::
    getNssSpillForwarderConfigCount () const
    {
      return this->NssSpillForwarderConfig_.size ();
    }

    const NssSpillForwarderConfigSet::NssSpillForwarderConfig_type& NssSpillForwarderConfigSet::
    getNssSpillForwarderConfig (int index) const
    {
      return this->NssSpillForwarderConfig_[index];
    }

    NssSpillForwarderConfigSet::NssSpillForwarderConfig_type& NssSpillForwarderConfigSet::
    getNssSpillForwarderConfigReference (int index)
    {
      return this->NssSpillForwarderConfig_[index];
    }

    bool NssSpillForwarderConfigSet::
    hasNssSpillForwarderConfig () const
    {
      return ! (this->NssSpillForwarderConfig_.empty ());
    }

    void NssSpillForwarderConfigSet::
    removeAllNssSpillForwarderConfig ()
    {
      this->NssSpillForwarderConfig_.clear ();
    }

    void NssSpillForwarderConfigSet::
    NssSpillForwarderConfig (const NssSpillForwarderConfig_sequence& s)
    {
      this->NssSpillForwarderConfig_ = s;
    }

    void NssSpillForwarderConfigSet::
    addNssSpillForwarderConfig (const NssSpillForwarderConfigSet::NssSpillForwarderConfig_type& newNssSpillForwarderConfig)
    {
      this->NssSpillForwarderConfig_.push_back (newNssSpillForwarderConfig);
    }
  }
}

#include <xsd/cxx/xml/dom/parsing-source.hxx>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

namespace novadaq
{
  namespace nss
  {
    // NssSpillForwarderConfigType
    //

    NssSpillForwarderConfigType::
    NssSpillForwarderConfigType ()
    : ::xml_schema::type (),
      SpillSource_ (this),
      SpillDestinationSet_ (this)
    {
    }

    NssSpillForwarderConfigType::
    NssSpillForwarderConfigType (const SpillSource_type& SpillSource)
    : ::xml_schema::type (),
      SpillSource_ (SpillSource, this),
      SpillDestinationSet_ (this)
    {
    }

    NssSpillForwarderConfigType::
    NssSpillForwarderConfigType (::std::auto_ptr< SpillSource_type > SpillSource)
    : ::xml_schema::type (),
      SpillSource_ (SpillSource, this),
      SpillDestinationSet_ (this)
    {
    }

    NssSpillForwarderConfigType::
    NssSpillForwarderConfigType (const NssSpillForwarderConfigType& x,
                                 ::xml_schema::flags f,
                                 ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      SpillSource_ (x.SpillSource_, f, this),
      SpillDestinationSet_ (x.SpillDestinationSet_, f, this)
    {
    }

    NssSpillForwarderConfigType::
    NssSpillForwarderConfigType (const ::xercesc::DOMElement& e,
                                 ::xml_schema::flags f,
                                 ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      SpillSource_ (this),
      SpillDestinationSet_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
        this->parse (p, f);
      }
    }

    void NssSpillForwarderConfigType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // SpillSource
        //
        if (n.name () == "SpillSource" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< SpillSource_type > r (
            SpillSource_traits::create (i, f, this));

          if (!SpillSource_.present ())
          {
            this->SpillSource_.set (r);
            continue;
          }
        }

        // SpillDestinationSet
        //
        if (n.name () == "SpillDestinationSet" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< SpillDestinationSet_type > r (
            SpillDestinationSet_traits::create (i, f, this));

          this->SpillDestinationSet_.push_back (r);
          continue;
        }

        break;
      }

      if (!SpillSource_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected element (NssSpillForwarderConfigType::SpillSource) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_element< char > (
            "SpillSource",
            "");
        }
      }
    }

    NssSpillForwarderConfigType* NssSpillForwarderConfigType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class NssSpillForwarderConfigType (*this, f, c);
    }

    NssSpillForwarderConfigType& NssSpillForwarderConfigType::
    operator= (const NssSpillForwarderConfigType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->SpillSource_ = x.SpillSource_;
        this->SpillDestinationSet_ = x.SpillDestinationSet_;
      }

      return *this;
    }

    NssSpillForwarderConfigType::
    ~NssSpillForwarderConfigType ()
    {
    }

    void NssSpillForwarderConfigType::
    copyNeededFields (const NssSpillForwarderConfigType& x)
    {
      if (x.hasSpillSource()) {
        if (! this->hasSpillSource()) {
          this->setSpillSource(x.getSpillSource());
        }
        else {
          copyTraits<SpillSource_type>::copyNeededFields(x.getSpillSource(), this->SpillSource());
        }
      }
      if (x.hasSpillDestinationSet() && x.getSpillDestinationSetCount() > 0) {
        if (! this->hasSpillDestinationSet() || this->getSpillDestinationSetCount() == 0) {
          for (::xml_schema::integer idx = 0; idx < x.getSpillDestinationSetCount(); ++idx) {
              this->addSpillDestinationSet(x.getSpillDestinationSet(idx));
          }
        }
        //else {
        //  copyTraits<SpillDestinationSet_type>::copyNeededFields(x.getSpillDestinationSet(), this->SpillDestinationSet());
        //}
      }
    }

    // SpillSourceType
    //

    SpillSourceType::
    SpillSourceType ()
    : ::xml_schema::type (),
      port_ (this)
    {
    }

    SpillSourceType::
    SpillSourceType (const port_type& port)
    : ::xml_schema::type (),
      port_ (port, this)
    {
    }

    SpillSourceType::
    SpillSourceType (const SpillSourceType& x,
                     ::xml_schema::flags f,
                     ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      port_ (x.port_, f, this)
    {
    }

    SpillSourceType::
    SpillSourceType (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f,
                     ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      port_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
        this->parse (p, f);
      }
    }

    void SpillSourceType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "port" && n.namespace_ ().empty ())
        {
          this->port_.set (port_traits::create (i, f, this));
          continue;
        }
      }

      if (!port_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (SpillSourceType::port) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "port",
            "");
        }
      }
    }

    SpillSourceType* SpillSourceType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class SpillSourceType (*this, f, c);
    }

    SpillSourceType& SpillSourceType::
    operator= (const SpillSourceType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->port_ = x.port_;
      }

      return *this;
    }

    SpillSourceType::
    ~SpillSourceType ()
    {
    }

    void SpillSourceType::
    copyNeededFields (const SpillSourceType& x)
    {
      if (x.hasPort()) {
        if (! this->hasPort()) {
          this->setPort(x.getPort());
        }
        else {
          copyTraits<port_type>::copyNeededFields(x.getPort(), this->port());
        }
      }
    }

    // SpillDestinationSetType
    //

    SpillDestinationSetType::
    SpillDestinationSetType ()
    : ::xml_schema::type (),
      SpillDestination_ (this)
    {
    }

    SpillDestinationSetType::
    SpillDestinationSetType (const SpillDestinationSetType& x,
                             ::xml_schema::flags f,
                             ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      SpillDestination_ (x.SpillDestination_, f, this)
    {
    }

    SpillDestinationSetType::
    SpillDestinationSetType (const ::xercesc::DOMElement& e,
                             ::xml_schema::flags f,
                             ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      SpillDestination_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
        this->parse (p, f);
      }
    }

    void SpillDestinationSetType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // SpillDestination
        //
        if (n.name () == "SpillDestination" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< SpillDestination_type > r (
            SpillDestination_traits::create (i, f, this));

          this->SpillDestination_.push_back (r);
          continue;
        }

        break;
      }
    }

    SpillDestinationSetType* SpillDestinationSetType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class SpillDestinationSetType (*this, f, c);
    }

    SpillDestinationSetType& SpillDestinationSetType::
    operator= (const SpillDestinationSetType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->SpillDestination_ = x.SpillDestination_;
      }

      return *this;
    }

    SpillDestinationSetType::
    ~SpillDestinationSetType ()
    {
    }

    void SpillDestinationSetType::
    copyNeededFields (const SpillDestinationSetType& x)
    {
      if (x.hasSpillDestination() && x.getSpillDestinationCount() > 0) {
        if (! this->hasSpillDestination() || this->getSpillDestinationCount() == 0) {
          for (::xml_schema::integer idx = 0; idx < x.getSpillDestinationCount(); ++idx) {
              this->addSpillDestination(x.getSpillDestination(idx));
          }
        }
        //else {
        //  copyTraits<SpillDestination_type>::copyNeededFields(x.getSpillDestination(), this->SpillDestination());
        //}
      }
    }

    // SpillDestinationType
    //

    SpillDestinationType::
    SpillDestinationType ()
    : ::xml_schema::type (),
      Destination_ (this),
      SpillTypeSet_ (this)
    {
    }

    SpillDestinationType::
    SpillDestinationType (const Destination_type& Destination,
                          const SpillTypeSet_type& SpillTypeSet)
    : ::xml_schema::type (),
      Destination_ (Destination, this),
      SpillTypeSet_ (SpillTypeSet, this)
    {
    }

    SpillDestinationType::
    SpillDestinationType (::std::auto_ptr< Destination_type > Destination,
                          ::std::auto_ptr< SpillTypeSet_type > SpillTypeSet)
    : ::xml_schema::type (),
      Destination_ (Destination, this),
      SpillTypeSet_ (SpillTypeSet, this)
    {
    }

    SpillDestinationType::
    SpillDestinationType (const SpillDestinationType& x,
                          ::xml_schema::flags f,
                          ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      Destination_ (x.Destination_, f, this),
      SpillTypeSet_ (x.SpillTypeSet_, f, this)
    {
    }

    SpillDestinationType::
    SpillDestinationType (const ::xercesc::DOMElement& e,
                          ::xml_schema::flags f,
                          ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      Destination_ (this),
      SpillTypeSet_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
        this->parse (p, f);
      }
    }

    void SpillDestinationType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // Destination
        //
        if (n.name () == "Destination" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< Destination_type > r (
            Destination_traits::create (i, f, this));

          if (!Destination_.present ())
          {
            this->Destination_.set (r);
            continue;
          }
        }

        // SpillTypeSet
        //
        if (n.name () == "SpillTypeSet" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< SpillTypeSet_type > r (
            SpillTypeSet_traits::create (i, f, this));

          if (!SpillTypeSet_.present ())
          {
            this->SpillTypeSet_.set (r);
            continue;
          }
        }

        break;
      }

      if (!Destination_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected element (SpillDestinationType::Destination) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_element< char > (
            "Destination",
            "");
        }
      }

      if (!SpillTypeSet_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected element (SpillDestinationType::SpillTypeSet) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_element< char > (
            "SpillTypeSet",
            "");
        }
      }
    }

    SpillDestinationType* SpillDestinationType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class SpillDestinationType (*this, f, c);
    }

    SpillDestinationType& SpillDestinationType::
    operator= (const SpillDestinationType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->Destination_ = x.Destination_;
        this->SpillTypeSet_ = x.SpillTypeSet_;
      }

      return *this;
    }

    SpillDestinationType::
    ~SpillDestinationType ()
    {
    }

    void SpillDestinationType::
    copyNeededFields (const SpillDestinationType& x)
    {
      if (x.hasDestination()) {
        if (! this->hasDestination()) {
          this->setDestination(x.getDestination());
        }
        else {
          copyTraits<Destination_type>::copyNeededFields(x.getDestination(), this->Destination());
        }
      }
      if (x.hasSpillTypeSet()) {
        if (! this->hasSpillTypeSet()) {
          this->setSpillTypeSet(x.getSpillTypeSet());
        }
        else {
          copyTraits<SpillTypeSet_type>::copyNeededFields(x.getSpillTypeSet(), this->SpillTypeSet());
        }
      }
    }

    // DestinationType
    //

    DestinationType::
    DestinationType ()
    : ::xml_schema::type (),
      enable_ (this),
      host_ (this),
      port_ (this)
    {
    }

    DestinationType::
    DestinationType (const enable_type& enable,
                     const host_type& host,
                     const port_type& port)
    : ::xml_schema::type (),
      enable_ (enable, this),
      host_ (host, this),
      port_ (port, this)
    {
    }

    DestinationType::
    DestinationType (const DestinationType& x,
                     ::xml_schema::flags f,
                     ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      enable_ (x.enable_, f, this),
      host_ (x.host_, f, this),
      port_ (x.port_, f, this)
    {
    }

    DestinationType::
    DestinationType (const ::xercesc::DOMElement& e,
                     ::xml_schema::flags f,
                     ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      enable_ (this),
      host_ (this),
      port_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
        this->parse (p, f);
      }
    }

    void DestinationType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "enable" && n.namespace_ ().empty ())
        {
          this->enable_.set (enable_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "host" && n.namespace_ ().empty ())
        {
          this->host_.set (host_traits::create (i, f, this));
          continue;
        }

        if (n.name () == "port" && n.namespace_ ().empty ())
        {
          this->port_.set (port_traits::create (i, f, this));
          continue;
        }
      }

      if (!enable_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (DestinationType::enable) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "enable",
            "");
        }
      }

      if (!host_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (DestinationType::host) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "host",
            "");
        }
      }

      if (!port_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (DestinationType::port) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "port",
            "");
        }
      }
    }

    DestinationType* DestinationType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class DestinationType (*this, f, c);
    }

    DestinationType& DestinationType::
    operator= (const DestinationType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->enable_ = x.enable_;
        this->host_ = x.host_;
        this->port_ = x.port_;
      }

      return *this;
    }

    DestinationType::
    ~DestinationType ()
    {
    }

    void DestinationType::
    copyNeededFields (const DestinationType& x)
    {
      if (x.hasEnable()) {
        if (! this->hasEnable()) {
          this->setEnable(x.getEnable());
        }
        else {
          copyTraits<enable_type>::copyNeededFields(x.getEnable(), this->enable());
        }
      }
      if (x.hasHost()) {
        if (! this->hasHost()) {
          this->setHost(x.getHost());
        }
        else {
          copyTraits<host_type>::copyNeededFields(x.getHost(), this->host());
        }
      }
      if (x.hasPort()) {
        if (! this->hasPort()) {
          this->setPort(x.getPort());
        }
        else {
          copyTraits<port_type>::copyNeededFields(x.getPort(), this->port());
        }
      }
    }

    // SpillTypeSetType
    //

    SpillTypeSetType::
    SpillTypeSetType ()
    : ::xml_schema::type (),
      SpillType_ (this)
    {
    }

    SpillTypeSetType::
    SpillTypeSetType (const SpillTypeSetType& x,
                      ::xml_schema::flags f,
                      ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      SpillType_ (x.SpillType_, f, this)
    {
    }

    SpillTypeSetType::
    SpillTypeSetType (const ::xercesc::DOMElement& e,
                      ::xml_schema::flags f,
                      ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      SpillType_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
        this->parse (p, f);
      }
    }

    void SpillTypeSetType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // SpillType
        //
        if (n.name () == "SpillType" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< SpillType_type > r (
            SpillType_traits::create (i, f, this));

          this->SpillType_.push_back (r);
          continue;
        }

        break;
      }
    }

    SpillTypeSetType* SpillTypeSetType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class SpillTypeSetType (*this, f, c);
    }

    SpillTypeSetType& SpillTypeSetType::
    operator= (const SpillTypeSetType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->SpillType_ = x.SpillType_;
      }

      return *this;
    }

    SpillTypeSetType::
    ~SpillTypeSetType ()
    {
    }

    void SpillTypeSetType::
    copyNeededFields (const SpillTypeSetType& x)
    {
      if (x.hasSpillType() && x.getSpillTypeCount() > 0) {
        if (! this->hasSpillType() || this->getSpillTypeCount() == 0) {
          for (::xml_schema::integer idx = 0; idx < x.getSpillTypeCount(); ++idx) {
              this->addSpillType(x.getSpillType(idx));
          }
        }
        //else {
        //  copyTraits<SpillType_type>::copyNeededFields(x.getSpillType(), this->SpillType());
        //}
      }
    }

    // SpillTypeType
    //

    SpillTypeType::
    SpillTypeType ()
    : ::xml_schema::type (),
      name_ (this)
    {
    }

    SpillTypeType::
    SpillTypeType (const name_type& name)
    : ::xml_schema::type (),
      name_ (name, this)
    {
    }

    SpillTypeType::
    SpillTypeType (const SpillTypeType& x,
                   ::xml_schema::flags f,
                   ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      name_ (x.name_, f, this)
    {
    }

    SpillTypeType::
    SpillTypeType (const ::xercesc::DOMElement& e,
                   ::xml_schema::flags f,
                   ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      name_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, false, false, true);
        this->parse (p, f);
      }
    }

    void SpillTypeType::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      while (p.more_attributes ())
      {
        const ::xercesc::DOMAttr& i (p.next_attribute ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        if (n.name () == "name" && n.namespace_ ().empty ())
        {
          this->name_.set (name_traits::create (i, f, this));
          continue;
        }
      }

      if (!name_.present ())
      {
        if ((f & ::novadaq::XMLSerializable::allow_missing_elements) == 0)
        {
          std::cerr << "ERROR: expected attribute (SpillTypeType::name) not found!" << std::endl;
          throw ::xsd::cxx::tree::expected_attribute< char > (
            "name",
            "");
        }
      }
    }

    SpillTypeType* SpillTypeType::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class SpillTypeType (*this, f, c);
    }

    SpillTypeType& SpillTypeType::
    operator= (const SpillTypeType& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->name_ = x.name_;
      }

      return *this;
    }

    SpillTypeType::
    ~SpillTypeType ()
    {
    }

    void SpillTypeType::
    copyNeededFields (const SpillTypeType& x)
    {
      if (x.hasName()) {
        if (! this->hasName()) {
          this->setName(x.getName());
        }
        else {
          copyTraits<name_type>::copyNeededFields(x.getName(), this->name());
        }
      }
    }

    // NssSpillForwarderConfigSet
    //

    NssSpillForwarderConfigSet::
    NssSpillForwarderConfigSet ()
    : ::xml_schema::type (),
      NssSpillForwarderConfig_ (this)
    {
    }

    NssSpillForwarderConfigSet::
    NssSpillForwarderConfigSet (const NssSpillForwarderConfigSet& x,
                                ::xml_schema::flags f,
                                ::xml_schema::container* c)
    : ::xml_schema::type (x, f, c),
      NssSpillForwarderConfig_ (x.NssSpillForwarderConfig_, f, this)
    {
    }

    NssSpillForwarderConfigSet::
    NssSpillForwarderConfigSet (const ::xercesc::DOMElement& e,
                                ::xml_schema::flags f,
                                ::xml_schema::container* c)
    : ::xml_schema::type (e, f | ::xml_schema::flags::base, c),
      NssSpillForwarderConfig_ (this)
    {
      if ((f & ::xml_schema::flags::base) == 0)
      {
        ::xsd::cxx::xml::dom::parser< char > p (e, true, false, false);
        this->parse (p, f);
      }
    }

    void NssSpillForwarderConfigSet::
    parse (::xsd::cxx::xml::dom::parser< char >& p,
           ::xml_schema::flags f)
    {
      for (; p.more_content (); p.next_content (false))
      {
        const ::xercesc::DOMElement& i (p.cur_element ());
        const ::xsd::cxx::xml::qualified_name< char > n (
          ::xsd::cxx::xml::dom::name< char > (i));

        // NssSpillForwarderConfig
        //
        if (n.name () == "NssSpillForwarderConfig" && n.namespace_ ().empty ())
        {
          ::std::auto_ptr< NssSpillForwarderConfig_type > r (
            NssSpillForwarderConfig_traits::create (i, f, this));

          this->NssSpillForwarderConfig_.push_back (r);
          continue;
        }

        break;
      }
    }

    NssSpillForwarderConfigSet* NssSpillForwarderConfigSet::
    _clone (::xml_schema::flags f,
            ::xml_schema::container* c) const
    {
      return new class NssSpillForwarderConfigSet (*this, f, c);
    }

    NssSpillForwarderConfigSet& NssSpillForwarderConfigSet::
    operator= (const NssSpillForwarderConfigSet& x)
    {
      if (this != &x)
      {
        static_cast< ::xml_schema::type& > (*this) = x;
        this->NssSpillForwarderConfig_ = x.NssSpillForwarderConfig_;
      }

      return *this;
    }

    NssSpillForwarderConfigSet::
    ~NssSpillForwarderConfigSet ()
    {
    }

    ::std::string NssSpillForwarderConfigSet::
    serialize () const
    {
      // To avoid problems with multi-threaded access to
      // CST XSD ser/deserialization code and underlying
      // Xerces-C++ code, we prevent concurrent access
      // to any serialization code by any class that
      // inherits from XMLSerializable via the use of a
      // static mutex in XMLSerializable.
      boost::mutex::scoped_lock lock(_serializationMutex);

      ::std::ostringstream oss;
      NssSpillForwarderConfigSet_ (oss, *this);
      return oss.str();
    }

    void NssSpillForwarderConfigSet::
    deserialize (const ::std::string& serializedData)
    {
      // To avoid problems with multi-threaded access to
      // CST XSD ser/deserialization code and underlying
      // Xerces-C++ code, we prevent concurrent access
      // to any deserialization code by any class that
      // inherits from XMLSerializable via the use of a
      // static mutex in XMLSerializable.
      boost::mutex::scoped_lock lock(_serializationMutex);

      // initialization for XSD
      ::xml_schema::flags flags = ::xml_schema::flags::dont_validate;
      ::xsd::cxx::xml::auto_initializer autoInit
            ((flags & ::xml_schema::flags::dont_initialize) == 0,
             (flags & ::xml_schema::flags::keep_dom) == 0);
      ::xsd::cxx::tree::error_handler< char > errorHandler;
      ::xml_schema::properties props;

      // wrap the string in an input stream
      ::std::istringstream iss (serializedData);
      ::xsd::cxx::xml::sax::std_input_source isrc (iss);

      // create a DOM from the input stream
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > doc (
          ::xsd::cxx::xml::dom::parse< char > (isrc, errorHandler, props, flags));
      errorHandler.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      // do the deserialization
      ::xsd::cxx::xml::dom::parser< char > parser (*(doc->getDocumentElement()), true, false, true);
      this->parse (parser, flags);
    }

    ::std::string NssSpillForwarderConfigSet::
    getClassName () const
    {
      return "novadaq::nss::NssSpillForwarderConfigSet";
    }

    ::boost::shared_ptr< ::novadaq::XMLSerializable > NssSpillForwarderConfigSet::
    clone () const
    {
      NssSpillForwarderConfigSet *copy = this->_clone ();
      boost::shared_ptr<novadaq::XMLSerializable> copyPtr (copy);
      return copyPtr;
    }

    void NssSpillForwarderConfigSet::
    registerForDeserialization ()
    {
      boost::shared_ptr<novadaq::XMLSerializable> msgPtr;
      novadaq::XMLDeserializationRegistry&
        deserRegistry = novadaq::XMLDeserializationRegistry::getInstance();
      msgPtr.reset(new NssSpillForwarderConfigSet());
      deserRegistry.registerClass(msgPtr->getClassName(), msgPtr);
    }

    void NssSpillForwarderConfigSet::
    copyNeededFields (const NssSpillForwarderConfigSet& x)
    {
      if (x.hasNssSpillForwarderConfig() && x.getNssSpillForwarderConfigCount() > 0) {
        if (! this->hasNssSpillForwarderConfig() || this->getNssSpillForwarderConfigCount() == 0) {
          for (::xml_schema::integer idx = 0; idx < x.getNssSpillForwarderConfigCount(); ++idx) {
              this->addNssSpillForwarderConfig(x.getNssSpillForwarderConfig(idx));
          }
        }
        //else {
        //  copyTraits<NssSpillForwarderConfig_type>::copyNeededFields(x.getNssSpillForwarderConfig(), this->NssSpillForwarderConfig());
        //}
      }
    }
  }
}

#include <istream>
#include <xsd/cxx/xml/sax/std-input-source.hxx>
#include <xsd/cxx/tree/error-handler.hxx>

namespace novadaq
{
  namespace nss
  {
    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (const ::std::string& u,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::tree::error_handler< char > h;

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      return ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet > (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (const ::std::string& u,
                                 ::xml_schema::error_handler& h,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet > (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (const ::std::string& u,
                                 ::xercesc::DOMErrorHandler& h,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          u, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet > (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (::std::istream& is,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::novadaq::nss::NssSpillForwarderConfigSet_ (isrc, f, p);
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (::std::istream& is,
                                 ::xml_schema::error_handler& h,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::novadaq::nss::NssSpillForwarderConfigSet_ (isrc, h, f, p);
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (::std::istream& is,
                                 ::xercesc::DOMErrorHandler& h,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::sax::std_input_source isrc (is);
      return ::novadaq::nss::NssSpillForwarderConfigSet_ (isrc, h, f, p);
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (::std::istream& is,
                                 const ::std::string& sid,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::novadaq::nss::NssSpillForwarderConfigSet_ (isrc, f, p);
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (::std::istream& is,
                                 const ::std::string& sid,
                                 ::xml_schema::error_handler& h,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0,
        (f & ::xml_schema::flags::keep_dom) == 0);

      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::novadaq::nss::NssSpillForwarderConfigSet_ (isrc, h, f, p);
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (::std::istream& is,
                                 const ::std::string& sid,
                                 ::xercesc::DOMErrorHandler& h,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xsd::cxx::xml::sax::std_input_source isrc (is, sid);
      return ::novadaq::nss::NssSpillForwarderConfigSet_ (isrc, h, f, p);
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (::xercesc::InputSource& i,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xsd::cxx::tree::error_handler< char > h;

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      h.throw_if_failed< ::xsd::cxx::tree::parsing< char > > ();

      return ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet > (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (::xercesc::InputSource& i,
                                 ::xml_schema::error_handler& h,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet > (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (::xercesc::InputSource& i,
                                 ::xercesc::DOMErrorHandler& h,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::parse< char > (
          i, h, p, f));

      if (!d.get ())
        throw ::xsd::cxx::tree::parsing< char > ();

      return ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet > (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (
          d, f | ::xml_schema::flags::own_dom, p));
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (const ::xercesc::DOMDocument& doc,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties& p)
    {
      if (f & ::xml_schema::flags::keep_dom)
      {
        ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
          static_cast< ::xercesc::DOMDocument* > (doc.cloneNode (true)));

        return ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet > (
          ::novadaq::nss::NssSpillForwarderConfigSet_ (
            d, f | ::xml_schema::flags::own_dom, p));
      }

      const ::xercesc::DOMElement& e (*doc.getDocumentElement ());
      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (n.name () == "NssSpillForwarderConfigSet" &&
          n.namespace_ () == "")
      {
        ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet > r (
          ::xsd::cxx::tree::traits< ::novadaq::nss::NssSpillForwarderConfigSet, char >::create (
            e, f, 0));
        return r;
      }

      throw ::xsd::cxx::tree::unexpected_element < char > (
        n.name (),
        n.namespace_ (),
        "NssSpillForwarderConfigSet",
        "");
    }

    ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet >
    NssSpillForwarderConfigSet_ (::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d,
                                 ::xml_schema::flags f,
                                 const ::xml_schema::properties&)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > c (
        ((f & ::xml_schema::flags::keep_dom) &&
         !(f & ::xml_schema::flags::own_dom))
        ? static_cast< ::xercesc::DOMDocument* > (d->cloneNode (true))
        : 0);

      ::xercesc::DOMDocument& doc (c.get () ? *c : *d);
      const ::xercesc::DOMElement& e (*doc.getDocumentElement ());

      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (f & ::xml_schema::flags::keep_dom)
        doc.setUserData (::xml_schema::dom::tree_node_key,
                         (c.get () ? &c : &d),
                         0);

      if (n.name () == "NssSpillForwarderConfigSet" &&
          n.namespace_ () == "")
      {
        ::std::auto_ptr< ::novadaq::nss::NssSpillForwarderConfigSet > r (
          ::xsd::cxx::tree::traits< ::novadaq::nss::NssSpillForwarderConfigSet, char >::create (
            e, f, 0));
        return r;
      }

      throw ::xsd::cxx::tree::unexpected_element < char > (
        n.name (),
        n.namespace_ (),
        "NssSpillForwarderConfigSet",
        "");
    }
  }
}

#include <ostream>
#include <xsd/cxx/tree/error-handler.hxx>
#include <xsd/cxx/xml/dom/serialization-source.hxx>

namespace novadaq
{
  namespace nss
  {
    void
    NssSpillForwarderConfigSet_ (::std::ostream& o,
                                 const ::novadaq::nss::NssSpillForwarderConfigSet& s,
                                 const ::xml_schema::namespace_infomap& m,
                                 const ::std::string& e,
                                 ::xml_schema::flags f)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0);

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (s, m, f));

      ::xsd::cxx::tree::error_handler< char > h;

      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
      }
    }

    void
    NssSpillForwarderConfigSet_ (::std::ostream& o,
                                 const ::novadaq::nss::NssSpillForwarderConfigSet& s,
                                 ::xml_schema::error_handler& h,
                                 const ::xml_schema::namespace_infomap& m,
                                 const ::std::string& e,
                                 ::xml_schema::flags f)
    {
      ::xsd::cxx::xml::auto_initializer i (
        (f & ::xml_schema::flags::dont_initialize) == 0);

      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (s, m, f));
      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    NssSpillForwarderConfigSet_ (::std::ostream& o,
                                 const ::novadaq::nss::NssSpillForwarderConfigSet& s,
                                 ::xercesc::DOMErrorHandler& h,
                                 const ::xml_schema::namespace_infomap& m,
                                 const ::std::string& e,
                                 ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (s, m, f));
      ::xsd::cxx::xml::dom::ostream_format_target t (o);
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    NssSpillForwarderConfigSet_ (::xercesc::XMLFormatTarget& t,
                                 const ::novadaq::nss::NssSpillForwarderConfigSet& s,
                                 const ::xml_schema::namespace_infomap& m,
                                 const ::std::string& e,
                                 ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (s, m, f));

      ::xsd::cxx::tree::error_handler< char > h;

      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        h.throw_if_failed< ::xsd::cxx::tree::serialization< char > > ();
      }
    }

    void
    NssSpillForwarderConfigSet_ (::xercesc::XMLFormatTarget& t,
                                 const ::novadaq::nss::NssSpillForwarderConfigSet& s,
                                 ::xml_schema::error_handler& h,
                                 const ::xml_schema::namespace_infomap& m,
                                 const ::std::string& e,
                                 ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (s, m, f));
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    NssSpillForwarderConfigSet_ (::xercesc::XMLFormatTarget& t,
                                 const ::novadaq::nss::NssSpillForwarderConfigSet& s,
                                 ::xercesc::DOMErrorHandler& h,
                                 const ::xml_schema::namespace_infomap& m,
                                 const ::std::string& e,
                                 ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::novadaq::nss::NssSpillForwarderConfigSet_ (s, m, f));
      if (!::xsd::cxx::xml::dom::serialize (t, *d, e, h, f))
      {
        throw ::xsd::cxx::tree::serialization< char > ();
      }
    }

    void
    NssSpillForwarderConfigSet_ (::xercesc::DOMDocument& d,
                                 const ::novadaq::nss::NssSpillForwarderConfigSet& s,
                                 ::xml_schema::flags)
    {
      ::xercesc::DOMElement& e (*d.getDocumentElement ());
      const ::xsd::cxx::xml::qualified_name< char > n (
        ::xsd::cxx::xml::dom::name< char > (e));

      if (n.name () == "NssSpillForwarderConfigSet" &&
          n.namespace_ () == "")
      {
        e << s;
      }
      else
      {
        throw ::xsd::cxx::tree::unexpected_element < char > (
          n.name (),
          n.namespace_ (),
          "NssSpillForwarderConfigSet",
          "");
      }
    }

    ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument >
    NssSpillForwarderConfigSet_ (const ::novadaq::nss::NssSpillForwarderConfigSet& s,
                                 const ::xml_schema::namespace_infomap& m,
                                 ::xml_schema::flags f)
    {
      ::xml_schema::dom::auto_ptr< ::xercesc::DOMDocument > d (
        ::xsd::cxx::xml::dom::serialize< char > (
          "NssSpillForwarderConfigSet",
          "",
          m, f));

      ::novadaq::nss::NssSpillForwarderConfigSet_ (*d, s, f);
      return d;
    }

    void
    operator<< (::xercesc::DOMElement& e, const NssSpillForwarderConfigType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // SpillSource
      //
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "SpillSource",
            e));

        if (! i.hasSpillSource ()) {
          std::cerr << "WARNING: attempting to serialize a NssSpillForwarderConfigType with an empty SpillSource field!" << std::endl;
        }
        s << i.SpillSource ();
      }

      // SpillDestinationSet
      //
      for (NssSpillForwarderConfigType::SpillDestinationSet_const_iterator
           b (i.SpillDestinationSet ().begin ()), n (i.SpillDestinationSet ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "SpillDestinationSet",
            e));

        s << *b;
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const SpillSourceType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // port
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "port",
            e));

        if (! i.hasPort ()) {
          std::cerr << "WARNING: attempting to serialize a SpillSourceType with an empty port field!" << std::endl;
        }
        a << i.port ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const SpillDestinationSetType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // SpillDestination
      //
      for (SpillDestinationSetType::SpillDestination_const_iterator
           b (i.SpillDestination ().begin ()), n (i.SpillDestination ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "SpillDestination",
            e));

        s << *b;
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const SpillDestinationType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // Destination
      //
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "Destination",
            e));

        if (! i.hasDestination ()) {
          std::cerr << "WARNING: attempting to serialize a SpillDestinationType with an empty Destination field!" << std::endl;
        }
        s << i.Destination ();
      }

      // SpillTypeSet
      //
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "SpillTypeSet",
            e));

        if (! i.hasSpillTypeSet ()) {
          std::cerr << "WARNING: attempting to serialize a SpillDestinationType with an empty SpillTypeSet field!" << std::endl;
        }
        s << i.SpillTypeSet ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const DestinationType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // enable
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "enable",
            e));

        if (! i.hasEnable ()) {
          std::cerr << "WARNING: attempting to serialize a DestinationType with an empty enable field!" << std::endl;
        }
        a << i.enable ();
      }

      // host
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "host",
            e));

        if (! i.hasHost ()) {
          std::cerr << "WARNING: attempting to serialize a DestinationType with an empty host field!" << std::endl;
        }
        a << i.host ();
      }

      // port
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "port",
            e));

        if (! i.hasPort ()) {
          std::cerr << "WARNING: attempting to serialize a DestinationType with an empty port field!" << std::endl;
        }
        a << i.port ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const SpillTypeSetType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // SpillType
      //
      for (SpillTypeSetType::SpillType_const_iterator
           b (i.SpillType ().begin ()), n (i.SpillType ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "SpillType",
            e));

        s << *b;
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const SpillTypeType& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // name
      //
      {
        ::xercesc::DOMAttr& a (
          ::xsd::cxx::xml::dom::create_attribute (
            "name",
            e));

        if (! i.hasName ()) {
          std::cerr << "WARNING: attempting to serialize a SpillTypeType with an empty name field!" << std::endl;
        }
        a << i.name ();
      }
    }

    void
    operator<< (::xercesc::DOMElement& e, const NssSpillForwarderConfigSet& i)
    {
      e << static_cast< const ::xml_schema::type& > (i);

      // NssSpillForwarderConfig
      //
      for (NssSpillForwarderConfigSet::NssSpillForwarderConfig_const_iterator
           b (i.NssSpillForwarderConfig ().begin ()), n (i.NssSpillForwarderConfig ().end ());
           b != n; ++b)
      {
        ::xercesc::DOMElement& s (
          ::xsd::cxx::xml::dom::create_element (
            "NssSpillForwarderConfig",
            e));

        s << *b;
      }
    }
  }
}

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

